#ifndef _AnaEeh_hh_
#define _AnaEeh_hh_

#include <string>
#include <iostream>
#include <fstream>
#include <marlin/Processor.h>
#include <TNtuple.h>
#include <TObject.h>
#include <TTree.h>
#include <TFile.h>
#include <stdexcept>
#include <cstdlib>

class TTree;

class AnaEeh  : public marlin::Processor
{
	public:

		Processor*  newProcessor() { return new AnaEeh ; }

		AnaEeh();

		~AnaEeh() {};

		void init();

		void processEvent( LCEvent * evtP );

		void end();

	protected:
		std::string _treeFileName;
		std::string _treeName;
		std::string _colName;

		int _overwrite, _leptonID, _fileID;
		TTree *_outputTree;

		int _Num, _eventNr, _FileNr;
		int nHDleptonM, nHDleptonP, nHDGamma, nHDQuark, nHDGluon, nHDOther;
		int nNePFO, nChPFO, nPhotonPFO, nMuonMPFO, nMuonPPFO, nEleMPFO, nElePPFO, nHadPFO, nBremPhM, nBremPhP;
		float _InvMass, _InvMassH, _RecoilMass, InvMass_ABC, InvMassH_ABC, RecoilMass_ABC;

		std::string _fileName;
		std::ostream *_output;
		std::string _histFileName;
};

#endif
