#ifndef _Trknum_hh_
#define _Trknum_hh_

#include <string>
#include <iostream>
#include <fstream>
#include <vector>
#include <marlin/Processor.h>
#include <EVENT/CalorimeterHit.h>
#include <EVENT/ReconstructedParticle.h>
#include <TNtuple.h>
#include <TObject.h>
#include <TTree.h>
#include <TFile.h>
#include <TVector3.h>

class TTree;

class Trknum  : public marlin::Processor
{
	public:

		Processor*  newProcessor() { return new Trknum ; }

		Trknum();

		~Trknum() {};

		void init();

		void processEvent( LCEvent * evtP );
            
                
		void end();

	protected:
		std::string _treeFileName;
		std::string _treeName;
		std::ostream *_output;
                std::string _colName;
                std::string _colName2;
		int _overwrite;
		TTree *_outputTree;
		TTree *_outputPFO;
                int _eventNr, num;
                float _thetaMC;
                int _type, _nPhiBump, _NH_ECALF10, _NH_ECALL20;
                float _MCPEn, _MCPP[3];
                int _nCH, _nMIPs, _nEMs, _nHADs, _nMuPFO, _nEPFO, _nPiPFO;
		int _NTrk, _NClu, _Charge, _EcalNHit, _HcalNHit, _CluNHit, _NLEcal, _NLHcal, _NH[16], _NL[16]; 
                float _TrkEn, _EcalEn, _HcalEn, _EClu, _graDepth,_cluDepth,_graAbsDepth, _maxDepth, _minDepth, _MaxDisHel, _MinDisHel, _FD_ECALF10, _FD_ECALL20, _FD_all, _FD_ECAL, _FD_HCAL, _FD[16];
                int _FDflag[8], _NHflag[8], _nFDE0, _nFDE1, _nFDE2, _nFDH0, _nFDH1, _nFDH2, _nENH0, _nENH1, _nENH2, _nENH3, _nENH4, _nHNH0, _nHNH1, _nHNH2, _nHNH3, _nHNH4, _nFD0, _nFD1, _nFD2, _nNH0, _nNH1, _nNH2, _nNH3, _nNH4;
                int _CluFlagID;
                float _maxDisHtoL, _minDisHtoL, _avDisHtoL,_avEnDisHtoL, _avDisHtoLE3, _avEnDisHtoLE3, _avE3overE2, _avDisHtoLE2, _avEnDisHtoLE2;
                float _EEClu_L10, _EEClu_R, _EEClu_r, _EEClu_p, _rms_Ecal, _rms_Hcal, _rms_Ecal2, _rms_Hcal2, _av_NHE, _av_NHH;
                int _AL_Ecal, _AL_Hcal;
		float _thetaDisCh, _thetaDisMip, _thetaDisEm, _thetaDisHad;
		float _dEdx;
};

#endif




